
var previousNavButton;
var currentNavButton;

var backShowing = false;
var hiding = false;

var lookingForAmazonUsername = false;

var FRONT; 

var backSize = {'width': '440','height': '335'};
var frontSize;

var updateFound = false;

var lastUpdateCheck = 0;

function load()
{
    

    setupParts();
	
	//releases = new Array();
    
    ElementUtils.show($("front"));
	
	FRONT = $("frontImg");
	

	document.getElementById("navbar").style.left = "37px";
	
	//alert("scroll bars: " + document.getElementById("scrollArea").object._scrollbars.length);
	//document.getElementById("scrollArea").object._scrollbars[0].hide(true);
	
	selectionTable = new HTListView(document.getElementById("scrollArea"),
							document.getElementById('listContent'));
							//document.getElementById('itemList'),
							//document.getElementById("previousPage"),
							//document.getElementById("nextPage"));
	
	amazonItemView = new AmazonItemView(document.getElementById("itemPoster"),
							document.getElementById("itemListPrice"),document.getElementById("itemListPriceLabel"),
                            document.getElementById("itemAmazonPrice"),document.getElementById("itemAmazonPriceLabel"),
							document.getElementById('selectedItemValues'),document.getElementById('singleItemArea'));
	
																			
	controller = new ItemListSelectionController(selectionTable,
							document.getElementById("singleItemArea"),amazonItemView);
                            
    
    

	
	selectionTable.setDelegate(controller);	
    	
	
	
	var _cont = controller;
	
	
	$("searchfield").onsearch = function(event)
	{
		_cont.amazonSearch(event);
	};
	
	
		
	$("categoryPopup").onchange = function(event)
	{
        
		_cont.cateogrySelected(event);
	}
	
	
	controller.setPreviousPageElement($("previousPage"));
	controller.setNextPageElement($("nextPage"));

	
	
	try
	{
		currentNavButton = document.getElementById(selectedType());
		changeSelectedNavButton(null,currentNavButton);
		
	}
	catch(err)
	{
		
	}			
																			
	//controller.defaultSearch();
	/*
	
	$("amazonImg").onclick = function(event)
	{
		amazonHomepage(event);
	}
	*/
    
   // clearCart();
    loadCartItems(controller);
	
	if(checkForUpdates())
		doCheckForUpdates();
		
}

function setupCountryPopup()
{

	//var country = widget.preferenceForKey("country");
	//if(country == null)
	//	country = "us";
	
	var selection = document.getElementById("countryPopup");
	selection.object.select.value = selectedCountry();
	var index = selection.object.getSelectedIndex();
	selection.object.setSelectedIndex(index);

}

function setupShowPopup()
{

	//var country = widget.preferenceForKey("country");
	//if(country == null)
	//	country = "us";
	
	var selection = document.getElementById("showByDefaultPopup");
	selection.object.select.value = defaultSearch();
	var index = selection.object.getSelectedIndex();
	selection.object.setSelectedIndex(index);

}

function setupUpdateCheckBox()
{
	if(checkForUpdates())
		$("updateCheckBox").checked = true;
	else
		$("updateCheckBox").checked = false;
}

function setupAmazonUsername()
{

	var selection = document.getElementById("amazonUsernameTextfield");
	if(amazonUsername() != null)
		selection.value = amazonUsername();

}

function testSelector(item)
{
	alert("this is only a test. if this had not be a test, we'd be displaying something useful.");
}



//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
	
	hiding = true;
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
	hiding = false;
	if(checkForUpdates() && !updateFound && timeForAnotherUpdateCheck())
    {   
        
		doCheckForUpdates();
    }
    if(updateFound && ElementUtils.isShown($("back")))
        beginPulsatingDownloadButton();

	if(ElementUtils.isShown($("front")))
    {
      
        changeSelectedNavButton(previousNavButton,currentNavButton);	
	}
	
	
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{

    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) 
	{
		
        widget.prepareForTransition("ToBack");
    }
	
	backShowing = true;
	
	if(updateFound)
		beginPulsatingDownloadButton();
	
	setupCountryPopup();
	setupShowPopup();
	setupAmazonUsername();
	setupUpdateCheckBox();
	
	refreshRequired = false;

	ElementUtils.hide($("front"));
	
	frontSize = getElementSize($("frontImg"));
	
	ElementUtils.show($("back"));


    if (window.widget) 
	{
		
        setTimeout('widget.performTransition();', 0);
		window.resizeTo(backSize['width'], backSize['height']);
		
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
	{
		window.resizeTo(frontSize['width'], frontSize['height']);
        widget.prepareForTransition("ToFront");
		
    }
	
	backShowing = false;
	
	ElementUtils.hide($("noUpdateText"));
	
	ElementUtils.hide($("back"));
  
	ElementUtils.show($("front"));
	
	//alert("amazon username: " + $("amazonUsernameTextfield").value);
	setSelectedAmazonUsername($("amazonUsernameTextfield").value);
	
	if(refreshRequired)
	{	
		changeSelectedNavButton(previousNavButton,currentNavButton);
	}
	if(lookingForAmazonUsername)
	{
		
		ElementUtils.hide(document.getElementById("amazonUsernameRequired"));
		if(amazonUsername() == null)
		{
			
			currentNavButton = document.getElementById("movies");
			changeSelectedNavButton(previousNavButton,currentNavButton);
			
		}
		lookingForAmazonUsername = false;
	}
	
	if (window.widget) 
	{
	
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget)
{
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}


function setCountry(event)
{

	setSelectedCountry(event.currentTarget.value);	
	refreshRequired = true;

}

function setDefaultSearch(event)
{
	setSelectedDefaultSearch(event.currentTarget.value);
	refreshRequired = true;
	
}

function setCheck(event)
{

	setCheckForUpdates(event.currentTarget.checked);
	
}

function setAmazonUsername(event)
{

	refreshRequired = true;
	
	switch (event.keyIdentifier)
	{
		
		case "Enter":
			showFront(event);
			break;
	}
	
	

}

function unselectAllInNavbar()
{
	var navbar = document.getElementById("navbar");
	for (var i=0; i<navbar.children.length; i++)// item in navbar.children())
	{
		try
		{
			var item = navbar.children[i];
			item.children[0].setAttribute("class", "navButton");
		
			item.object._setPressed(false);
		}
		catch(err)
		{
			//the shopping cart isn't an AppleButton.
		}

	}
}


function changeSelectedNavButton(previous,current)
{
	unselectAllInNavbar();
	
    //the cart icon is a special case
	if(previous != null && previous.id == "cart")
	{
		document.getElementById("cartImg").src = "Images/cart_unselected.gif";
	}		
	
	
	if(current != null)
	{
		
		current.children[0].setAttribute("class", "selectedNavButton");
		try
		{
			current.object._setPressed(true);
		}
		catch(err)
		{
			//the cart isn't an AppleButton
		}
		setSelectedType(current.id);
		if(current.id == "wishlist")
		{
			
			if(amazonUsername() == null)
			{
				lookingForAmazonUsername = true;
				controller.needAmazonUsername();
			}
			else
			{
				
				$("searchfield").setAttribute("disabled","disabled");
				$("searchfield").setAttribute("placeholder","");
				
				controller.wishlistSearch();
				
			}
		}
		else if(current.id == "cart")
		{
			$("searchfield").setAttribute("disabled","disabled");
			$("searchfield").setAttribute("placeholder","");
		
			document.getElementById("cartImg").src = "Images/cart_selected.gif";
			controller.showCart();
		}
		else
		{
			//alert("set search field. " + current.id);
			$("searchfield").setAttribute("placeholder","Search " + current.id);
			$("searchfield").removeAttribute("disabled");
			
			
                controller.defaultSearch();
            
		}
	}
}


function clickedonNavButton(event)
{

	previousNavButton = currentNavButton;

	currentNavButton = event.toElement.offsetParent;
	
	changeSelectedNavButton(previousNavButton,currentNavButton);	

}



function amazonHomepage(event)
{
	if (window.widget)
	{
	
		release = new AmazonBrowseNode(selectedType(),selectedCountry());
	
		widget.openURL(release.createHomepageURL());
	
   }
	
}






function widgetHomepage(event)
{
    if(window.widget)
		widget.openURL("http://www.humantrained.com/widgets");
}


function widgetFeedback(event)
{
    if(window.widget)
		widget.openURL("mailto:amazonmedia-feedback@humantrained.com?subject=Amazon%20Media%20Feedback");
}

function widgetDonate(event)
{
	if(window.widget)
		widget.openURL("http://www.humantrained.com/widgets/donate.php");
}


function defaultSearchChange(event)
{
    // Insert Code Here
}

function timeForAnotherUpdateCheck()
{
    var date = new Date();
    var time = date.getTime();
    
    var timeBetween = 24 * 60 * 60 * 60 * 1000;

    if( time > lastUpdateCheck + timeBetween )
    {
        
        return true;
    }
    else
    {
        
        return false;
    }
    

}

function doCheckForUpdates(event)
{
    var appcast = new Appcast("http://www.humantrained.com/widgets/version_info.php?version=latest&appcast=YES&name=AmazonWidget")
	appcast.onload = function(appcast)
	{
        var date = new Date();
        lastUpdateCheck = date.getTime();
		//alert("most recent: " + appcast.version);
		if(appcast.version != appcast.currentVersion())
		{
			
			ElementUtils.show($("downloadUpdateButton"));
            updateFound = true;
			var url = appcast.url;
			$("downloadUpdateButton").onclick = function(event)
			{
				if(window.widget)
					widget.openURL(url);
			}
			beginPulsatingDownloadButton();
           
            $("changelog").style.height = "185px";
            ElementUtils.show($("changelogLabel"));
            ElementUtils.show($("changelogScrollArea"));
            ElementUtils.show($("changelogCloseButton"));
            
            $("changelogContent").innerHTML = appcast.getDescription();
            ElementUtils.show($("changelog"));
            
	
           
            
			if(!backShowing)
				showBack();
				
		}
		else if(backShowing)
		{
			ElementUtils.show($("noUpdateText"));
		}
		
	
	}
	appcast.load();
	
	
	
}

function beginPulsatingDownloadButton()
{
	
	setTimeout('waxoff()', 0);
}

function waxon()
{
	
	setTimeout('waxoff()',200);
	$("downloadUpdateButton").style.color = "white";
	
}

function waxoff()
{
	//don't flash if the user can't see it.
	if(!backShowing || hiding)
		return;
	setTimeout('waxon()',200);
	$("downloadUpdateButton").style.color = "red";
	


}

function downloadUpdate(event)
{
    // Insert Code Here
}


function rectResizeHandler( rectAnimation, currentRect, startingRect, finishingRect )
{

    $("changelog").style.height = currentRect.bottom + "px";

 
}



function closeChangeLog(event)
{
   
this.collapseAnimator = new AppleAnimator (this.animationDuration, this.animationInterval);

    var original = getElementSize($("changelog"));
    //alert("original: " + original['height']);
    var originalRect = new AppleRect(0, 0, original['width'], original['height']);
    var collapseRect = new AppleRect(0, 0, original['width'], 10);
    var collapseAnimator = new AppleAnimator (250, 25);
    var theCollapseAnimation = new AppleRectAnimation( originalRect, collapseRect,  rectResizeHandler );
    collapseAnimator.addAnimation(theCollapseAnimation);
		
   
    collapseAnimator.oncomplete = function()
    {
			
           
            ElementUtils.hide($("changelog"));
    }

    ElementUtils.hide($("changelogLabel"));
    ElementUtils.hide($("changelogCloseButton"));
	
    ElementUtils.hide($("changelogScrollArea"));


		
    collapseAnimator.start();

    //ElementUtils.hide($("changelog"));
}
